Subject: Re: [PATCH 04/16] mm: allow PF_MEMALLOC from softirq context

From: Sebastian Andrzej Siewior <[email-masked]>
Date: Sun, 8 Jul 2012 20:12:11 +0200

On Wed, Jun 27, 2012 at 09:26:14AM +0100, Mel Gorman wrote:
> > > diff --git a/mm/page_alloc.c b/mm/page_alloc.c
> > > index b6c0727..5c6d9c6 100644
> > > --- a/mm/page_alloc.c
> > > +++ b/mm/page_alloc.c
> > > @@ -2265,7 +2265,11 @@ gfp_to_alloc_flags(gfp_t gfp_mask)
> > >  	if (likely(!(gfp_mask & __GFP_NOMEMALLOC))) {
> > >  		if (gfp_mask & __GFP_MEMALLOC)
> > >  			alloc_flags |= ALLOC_NO_WATERMARKS;
> > > -		else if (likely(!(gfp_mask & __GFP_NOMEMALLOC)) && !in_interrupt())
> > > +		else if (in_serving_softirq() && (current->flags & PF_MEMALLOC))
> > > +			alloc_flags |= ALLOC_NO_WATERMARKS;
> > > +		else if (!in_interrupt() &&
> > > +				((current->flags & PF_MEMALLOC) ||
> > > +				 unlikely(test_thread_flag(TIF_MEMDIE))))
> > >  			alloc_flags |= ALLOC_NO_WATERMARKS;
> > >  	}
> > 
> > You allocate in RX path with __GFP_MEMALLOC and your sk->sk_allocation has
> > also __GFP_MEMALLOC set. That means you should get ALLOC_NO_WATERMARKS in
> > alloc_flags.
> 
> In the cases where they are annotated correctly, yes. It is recordeed if
> the page gets allocated from the PFMEMALLOC reserves. If the received
> packet is not SOCK_MEMALLOC and the page was allocated from PFMEMALLOC
> reserves it is then discarded and the packet must be retransmitted.

Let me try again:
- lets assume your allocation happens with alloc_page(), without
  __GFP_MEMALLOC in GFP_FLAGS and with PF_MEMALLOC in current->flags. Now
  you may get memory which you wouldn't receive otherwise (without
  PF_MEMALLOC). Okay, understood. So you don't have to annotate each page
  allocation in your receive path for instance as long as the process has the
  flag set.
- lets assume your allocation happens with kmalloc() without __GFP_MEMALLOC
  and current->flags has PF_MEMALLOC ORed and your SLAB pool is empty. This
  forces SLAB to allocate more pages from the buddy allocator with it will
  receive more likely (due to ->current->flags + PF_MEMALLOC) but SLAB will
  drop this extra memory because the page has ->pf_memory (or something like
  that) set and the GFP_FLAGS do not have __GFP_MEMALLOC set.

Is there something I missed?

Sebastian

--
To unsubscribe, send a message with 'unsubscribe linux-mm' in
the body to [email-masked].  For more info on Linux MM,
see: http://www.linux-mm.org/ .
Don't email: <a href=mailto:"[email-masked]"> [email-masked] </a>